/*============================================================================
  File:     Parallelism.sql

  Summary:  Create some parallelism waits

  SQL Server Versions: 2005 onwards
------------------------------------------------------------------------------
  Written by Paul S. Randal, SQLskills.com

  (c) 2020, SQLskills.com. All rights reserved.

  For more scripts and sample code, check out 
    https://www.SQLskills.com

  You may alter this code for your own *non-commercial* purposes. You may
  republish altered code as long as you include this copyright and give due
  credit, but you must obtain prior permission before blogging this code.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

/*
USE [master];
GO

IF DATABASEPROPERTYEX (N'ParallelismTest', N'Version') > 0
BEGIN
	ALTER DATABASE [ParallelismTest] SET SINGLE_USER
		WITH ROLLBACK IMMEDIATE;
	DROP DATABASE [ParallelismTest];
END
GO

RESTORE DATABASE [ParallelismTest] FROM
DISK = N'D:\SQLskills\DemoBackups\Parallelism.bak'
WITH
	MOVE N'ParallelismTest' TO N'D:\SQLskills\ParallelismTest.mdf',
	MOVE N'ParallelismTest_log' TO N'D:\SQLskills\ParallelismTest_log.ldf',
	REPLACE, STATS;
GO
*/

-- Clear latches and waits

USE [ParallelismTest];
GO

SET NOCOUNT ON;
GO

SET STATISTICS TIME ON;
GO

DECLARE @ExecString NVARCHAR(MAX);

WHILE (1=1)
BEGIN
	-- Calculate doc name length
	SELECT @ExecString = '
	DECLARE @DocID int, @DocName varchar(100), @DocType int, @c4 int, @c5 int, @c6 int, @c7 int, @c8 int, @c9 int, @c10 int, @c11 int, @c12 int, @c13 int, @c14 int, @c15 int, @c16 int, @c17 int, @c18 int, @c19 int, @c20 int, @c21 int, @c22 int, @c23 int, @c24 int, @c25 int, @c26 int, @c27 int, @c28 int, @c29 int, @c30 int, @c31 int, @c32 int, @c33 int, @c34 int, @c35 int, @c36 int, @c37 int, @c38 int, @c39 int, @c40 int, @c41 int, @c42 int, @c43 int, @c44 int, @c45 int, @c46 int, @c47 int, @c48 int, @c49 int, @c50 int, @c51 int, @c52 int, @c53 int, @c54 int, @c55 int, @c56 int, @c57 int, @c58 int, @c59 int, @c60 int, @c61 int, @c62 int, @c63 int, @c64 int, @c65 int, @c66 int, @c67 int, @c68 int, @c69 int, @c70 int, @c71 int, @c72 int, @c73 int, @c74 int, @c75 int, @c76 int, @c77 int, @c78 int, @c79 int, @c80 int, @c81 int, @c82 int, @c83 int, @c84 int, @c85 int, @c86 int, @c87 int, @c88 int, @c89 int, @c90 int, @c91 int, @c92 int, @c93 int, @c94 int, @c95 int, @c96 int, @c97 int, @c98 int, @c99 int, @c100 int, @c101 int, @c102 int, @c103 int, @c104 int, @c105 int, @c106 int, @c107 int, @c108 int, @c109 int, @c110 int, @c111 int, @c112 int, @c113 int, @c114 int, @c115 int, @c116 int, @c117 int, @c118 int, @c119 int, @c120 int, @c121 int, @c122 int, @c123 int, @c124 int, @c125 int, @c126 int, @c127 int, @c128 int, @c129 int, @c130 int, @c131 int, @c132 int, @c133 int, @c134 int, @c135 int, @c136 int, @c137 int, @c138 int, @c139 int, @c140 int, @c141 int, @c142 int, @c143 int, @c144 int, @c145 int, @c146 int, @c147 int, @c148 int, @c149 int, @c150 int, @c151 int, @c152 int, @c153 int, @c154 int, @c155 int, @c156 int, @c157 int, @c158 int, @c159 int, @c160 int, @c161 int, @c162 int, @c163 int, @c164 int, @c165 int, @c166 int, @c167 int, @c168 int, @c169 int, @c170 int, @c171 int, @c172 int, @c173 int, @c174 int, @c175 int, @c176 int, @c177 int, @c178 int, @c179 int, @c180 int, @c181 int, @c182 int, @c183 int, @c184 int, @c185 int, @c186 int, @c187 int, @c188 int, @c189 int, @c190 int, @c191 int, @c192 int, @c193 int, @c194 int, @c195 int, @c196 int, @c197 int, @c198 int, @c199 int, @c200 int, @c201 int, @c202 int, @c203 int, @c204 int, @c205 int, @c206 int, @c207 int, @c208 int, @c209 int, @c210 int, @c211 int, @c212 int, @c213 int, @c214 int, @c215 int, @c216 int, @c217 int, @c218 int, @c219 int, @c220 int, @c221 int, @c222 int, @c223 int, @c224 int, @c225 int, @c226 int, @c227 int, @c228 int, @c229 int, @c230 int, @c231 int, @c232 int, @c233 int, @c234 int, @c235 int, @c236 int, @c237 int, @c238 int, @c239 int, @c240 int, @c241 int, @c242 int, @c243 int, @c244 int, @c245 int, @c246 int, @c247 int, @c248 int, @c249 int, @c250 int, @c251 int, @c252 int, @c253 int, @c254 int, @c255 int, @c256 int, @c257 int, @c258 int, @c259 int, @c260 int, @c261 int, @c262 int, @c263 int, @c264 int, @c265 int, @c266 int, @c267 int, @c268 int, @c269 int, @c270 int, @c271 int, @c272 int, @c273 int, @c274 int, @c275 int, @c276 int, @c277 int, @c278 int, @c279 int, @c280 int, @c281 int, @c282 int, @c283 int, @c284 int, @c285 int, @c286 int, @c287 int, @c288 int, @c289 int, @c290 int, @c291 int, @c292 int, @c293 int, @c294 int, @c295 int, @c296 int, @c297 int, @c298 int, @c299 int, @c300 int, @c301 int, @c302 int, @c303 int, @c304 int, @c305 int, @c306 int, @c307 int, @c308 int, @c309 int, @c310 int, @c311 int, @c312 int, @c313 int, @c314 int, @c315 int, @c316 int, @c317 int, @c318 int, @c319 int, @c320 int, @c321 int, @c322 int, @c323 int, @c324 int, @c325 int, @c326 int, @c327 int, @c328 int, @c329 int, @c330 int, @c331 int, @c332 int, @c333 int, @c334 int, @c335 int, @c336 int, @c337 int, @c338 int, @c339 int, @c340 int, @c341 int, @c342 int, @c343 int, @c344 int, @c345 int, @c346 int, @c347 int, @c348 int, @c349 int, @c350 int, @c351 int, @c352 int, @c353 int, @c354 int, @c355 int, @c356 int, @c357 int, @c358 int, @c359 int, @c360 int, @c361 int, @c362 int, @c363 int, @c364 int, @c365 int, @c366 int, @c367 int, @c368 int, @c369 int, @c370 int, @c371 int, @c372 int, @c373 int, @c374 int, @c375 int, @c376 int, @c377 int, @c378 int, @c379 int, @c380 int, @c381 int, @c382 int, @c383 int, @c384 int, @c385 int, @c386 int, @c387 int, @c388 int, @c389 int, @c390 int, @c391 int, @c392 int, @c393 int, @c394 int, @c395 int, @c396 int, @c397 int, @c398 int, @c399 int, @c400 int, @c401 int, @c402 int, @c403 int, @c404 int, @c405 int, @c406 int, @c407 int, @c408 int, @c409 int, @c410 int, @c411 int, @c412 int, @c413 int, @c414 int, @c415 int, @c416 int, @c417 int, @c418 int, @c419 int, @c420 int, @c421 int, @c422 int, @c423 int, @c424 int, @c425 int, @c426 int, @c427 int, @c428 int, @c429 int, @c430 int, @c431 int, @c432 int, @c433 int, @c434 int, @c435 int, @c436 int, @c437 int, @c438 int, @c439 int, @c440 int, @c441 int, @c442 int, @c443 int, @c444 int, @c445 int, @c446 int, @c447 int, @c448 int, @c449 int, @c450 int, @c451 int, @c452 int, @c453 int, @c454 int, @c455 int, @c456 int, @c457 int, @c458 int, @c459 int, @c460 int, @c461 int, @c462 int, @c463 int, @c464 int, @c465 int, @c466 int, @c467 int, @c468 int, @c469 int, @c470 int, @c471 int, @c472 int, @c473 int, @c474 int, @c475 int, @c476 int, @c477 int, @c478 int, @c479 int, @c480 int, @c481 int, @c482 int, @c483 int, @c484 int, @c485 int, @c486 int, @c487 int, @c488 int, @c489 int, @c490 int, @c491 int, @c492 int, @c493 int, @c494 int, @c495 int, @c496 int, @c497 int, @c498 int, @c499 int, @c500 int, @c501 int, @c502 int, @c503 int, @c504 int, @c505 int, @c506 int, @c507 int, @c508 int, @c509 int, @c510 int, @c511 int, @c512 int, @c513 int, @c514 int, @c515 int, @c516 int, @c517 int, @c518 int, @c519 int, @c520 int, @c521 int, @c522 int, @c523 int, @c524 int, @c525 int, @c526 int, @c527 int, @c528 int, @c529 int, @c530 int, @c531 int, @c532 int, @c533 int, @c534 int, @c535 int, @c536 int, @c537 int, @c538 int, @c539 int, @c540 int, @c541 int, @c542 int, @c543 int, @c544 int, @c545 int, @c546 int, @c547 int, @c548 int, @c549 int, @c550 int, @c551 int, @c552 int, @c553 int, @c554 int, @c555 int, @c556 int, @c557 int, @c558 int, @c559 int, @c560 int, @c561 int, @c562 int, @c563 int, @c564 int, @c565 int, @c566 int, @c567 int, @c568 int, @c569 int, @c570 int, @c571 int, @c572 int, @c573 int, @c574 int, @c575 int, @c576 int, @c577 int, @c578 int, @c579 int, @c580 int, @c581 int, @c582 int, @c583 int, @c584 int, @c585 int, @c586 int, @c587 int, @c588 int, @c589 int, @c590 int, @c591 int, @c592 int, @c593 int, @c594 int, @c595 int, @c596 int, @c597 int, @c598 int, @c599 int, @c600 int, @c601 int, @c602 int, @c603 int, @c604 int, @c605 int, @c606 int, @c607 int, @c608 int, @c609 int, @c610 int, @c611 int, @c612 int, @c613 int, @c614 int, @c615 int, @c616 int, @c617 int, @c618 int, @c619 int, @c620 int, @c621 int, @c622 int, @c623 int, @c624 int, @c625 int, @c626 int, @c627 int, @c628 int, @c629 int, @c630 int, @c631 int, @c632 int, @c633 int, @c634 int, @c635 int, @c636 int, @c637 int, @c638 int, @c639 int, @c640 int, @c641 int, @c642 int, @c643 int, @c644 int, @c645 int, @c646 int, @c647 int, @c648 int, @c649 int, @c650 int, @c651 int, @c652 int, @c653 int, @c654 int, @c655 int, @c656 int, @c657 int, @c658 int, @c659 int, @c660 int, @c661 int, @c662 int, @c663 int, @c664 int, @c665 int, @c666 int, @c667 int, @c668 int, @c669 int, @c670 int, @c671 int, @c672 int, @c673 int, @c674 int, @c675 int, @c676 int, @c677 int, @c678 int, @c679 int, @c680 int, @c681 int, @c682 int, @c683 int, @c684 int, @c685 int, @c686 int, @c687 int, @c688 int, @c689 int, @c690 int, @c691 int, @c692 int, @c693 int, @c694 int, @c695 int, @c696 int, @c697 int, @c698 int, @c699 int, @c700 int, @c701 int, @c702 int, @c703 int, @c704 int, @c705 int, @c706 int, @c707 int, @c708 int, @c709 int, @c710 int, @c711 int, @c712 int, @c713 int, @c714 int, @c715 int, @c716 int, @c717 int, @c718 int, @c719 int, @c720 int, @c721 int, @c722 int, @c723 int, @c724 int, @c725 int, @c726 int, @c727 int, @c728 int, @c729 int, @c730 int, @c731 int, @c732 int, @c733 int, @c734 int, @c735 int, @c736 int, @c737 int, @c738 int, @c739 int, @c740 int, @c741 int, @c742 int, @c743 int, @c744 int, @c745 int, @c746 int, @c747 int, @c748 int, @c749 int, @c750 int, @c751 int, @c752 int, @c753 int, @c754 int, @c755 int, @c756 int, @c757 int, @c758 int, @c759 int, @c760 int, @c761 int, @c762 int, @c763 int, @c764 int, @c765 int, @c766 int, @c767 int, @c768 int, @c769 int, @c770 int, @c771 int, @c772 int, @c773 int, @c774 int, @c775 int, @c776 int, @c777 int, @c778 int, @c779 int, @c780 int, @c781 int, @c782 int, @c783 int, @c784 int, @c785 int, @c786 int, @c787 int, @c788 int, @c789 int, @c790 int, @c791 int, @c792 int, @c793 int, @c794 int, @c795 int, @c796 int, @c797 int, @c798 int, @c799 int, @c800 int, @c801 int, @c802 int, @c803 int, @c804 int, @c805 int, @c806 int, @c807 int, @c808 int, @c809 int, @c810 int, @c811 int, @c812 int, @c813 int, @c814 int, @c815 int, @c816 int, @c817 int, @c818 int, @c819 int, @c820 int, @c821 int, @c822 int, @c823 int, @c824 int, @c825 int, @c826 int, @c827 int, @c828 int, @c829 int, @c830 int, @c831 int, @c832 int, @c833 int, @c834 int, @c835 int, @c836 int, @c837 int, @c838 int, @c839 int, @c840 int, @c841 int, @c842 int, @c843 int, @c844 int, @c845 int, @c846 int, @c847 int, @c848 int, @c849 int, @c850 int, @c851 int, @c852 int, @c853 int, @c854 int, @c855 int, @c856 int, @c857 int, @c858 int, @c859 int, @c860 int, @c861 int, @c862 int, @c863 int, @c864 int, @c865 int, @c866 int, @c867 int, @c868 int, @c869 int, @c870 int, @c871 int, @c872 int, @c873 int, @c874 int, @c875 int, @c876 int, @c877 int, @c878 int, @c879 int, @c880 int, @c881 int, @c882 int, @c883 int, @c884 int, @c885 int, @c886 int, @c887 int, @c888 int, @c889 int, @c890 int, @c891 int, @c892 int, @c893 int, @c894 int, @c895 int, @c896 int, @c897 int, @c898 int, @c899 int, @c900 int, @c901 int, @c902 int, @c903 int, @c904 int, @c905 int, @c906 int, @c907 int, @c908 int, @c909 int, @c910 int, @c911 int, @c912 int, @c913 int, @c914 int, @c915 int, @c916 int, @c917 int, @c918 int, @c919 int, @c920 int, @c921 int, @c922 int, @c923 int, @c924 int, @c925 int, @c926 int, @c927 int, @c928 int, @c929 int, @c930 int, @c931 int, @c932 int, @c933 int, @c934 int, @c935 int, @c936 int, @c937 int, @c938 int, @c939 int, @c940 int, @c941 int, @c942 int, @c943 int, @c944 int, @c945 int, @c946 int, @c947 int, @c948 int, @c949 int, @c950 int, @c951 int, @c952 int, @c953 int, @c954 int, @c955 int, @c956 int, @c957 int, @c958 int, @c959 int, @c960 int, @c961 int, @c962 int, @c963 int, @c964 int, @c965 int, @c966 int, @c967 int, @c968 int, @c969 int, @c970 int, @c971 int, @c972 int, @c973 int, @c974 int, @c975 int, @c976 int, @c977 int, @c978 int, @c979 int, @c980 int, @c981 int, @c982 int, @c983 int, @c984 int, @c985 int, @c986 int, @c987 int, @c988 int, @c989 int, @c990 int, @c991 int, @c992 int, @c993 int, @c994 int, @c995 int, @c996 int, @c997 int, @c998 int, @c999 int, @c1000 int
	
	SELECT TOP 10
		@DocID=DocID, @DocName=DocName, @DocType=DocType, @c4=c4, @c5=c5, @c6=c6, @c7=c7, @c8=c8, @c9=c9, @c10=c10, @c11=c11, @c12=c12, @c13=c13, @c14=c14, @c15=c15, @c16=c16, @c17=c17, @c18=c18, @c19=c19, @c20=c20, @c21=c21, @c22=c22, @c23=c23, @c24=c24, @c25=c25, @c26=c26, @c27=c27, @c28=c28, @c29=c29, @c30=c30, @c31=c31, @c32=c32, @c33=c33, @c34=c34, @c35=c35, @c36=c36, @c37=c37, @c38=c38, @c39=c39, @c40=c40, @c41=c41, @c42=c42, @c43=c43, @c44=c44, @c45=c45, @c46=c46, @c47=c47, @c48=c48, @c49=c49, @c50=c50, @c51=c51, @c52=c52, @c53=c53, @c54=c54, @c55=c55, @c56=c56, @c57=c57, @c58=c58, @c59=c59, @c60=c60, @c61=c61, @c62=c62, @c63=c63, @c64=c64, @c65=c65, @c66=c66, @c67=c67, @c68=c68, @c69=c69, @c70=c70, @c71=c71, @c72=c72, @c73=c73, @c74=c74, @c75=c75, @c76=c76, @c77=c77, @c78=c78, @c79=c79, @c80=c80, @c81=c81, @c82=c82, @c83=c83, @c84=c84, @c85=c85, @c86=c86, @c87=c87, @c88=c88, @c89=c89, @c90=c90, @c91=c91, @c92=c92, @c93=c93, @c94=c94, @c95=c95, @c96=c96, @c97=c97, @c98=c98, @c99=c99, @c100=c100, @c101=c101, @c102=c102, @c103=c103, @c104=c104, @c105=c105, @c106=c106, @c107=c107, @c108=c108, @c109=c109, @c110=c110, @c111=c111, @c112=c112, @c113=c113, @c114=c114, @c115=c115, @c116=c116, @c117=c117, @c118=c118, @c119=c119, @c120=c120, @c121=c121, @c122=c122, @c123=c123, @c124=c124, @c125=c125, @c126=c126, @c127=c127, @c128=c128, @c129=c129, @c130=c130, @c131=c131, @c132=c132, @c133=c133, @c134=c134, @c135=c135, @c136=c136, @c137=c137, @c138=c138, @c139=c139, @c140=c140, @c141=c141, @c142=c142, @c143=c143, @c144=c144, @c145=c145, @c146=c146, @c147=c147, @c148=c148, @c149=c149, @c150=c150, @c151=c151, @c152=c152, @c153=c153, @c154=c154, @c155=c155, @c156=c156, @c157=c157, @c158=c158, @c159=c159, @c160=c160, @c161=c161, @c162=c162, @c163=c163, @c164=c164, @c165=c165, @c166=c166, @c167=c167, @c168=c168, @c169=c169, @c170=c170, @c171=c171, @c172=c172, @c173=c173, @c174=c174, @c175=c175, @c176=c176, @c177=c177, @c178=c178, @c179=c179, @c180=c180, @c181=c181, @c182=c182, @c183=c183, @c184=c184, @c185=c185, @c186=c186, @c187=c187, @c188=c188, @c189=c189, @c190=c190, @c191=c191, @c192=c192, @c193=c193, @c194=c194, @c195=c195, @c196=c196, @c197=c197, @c198=c198, @c199=c199, @c200=c200, @c201=c201, @c202=c202, @c203=c203, @c204=c204, @c205=c205, @c206=c206, @c207=c207, @c208=c208, @c209=c209, @c210=c210, @c211=c211, @c212=c212, @c213=c213, @c214=c214, @c215=c215, @c216=c216, @c217=c217, @c218=c218, @c219=c219, @c220=c220, @c221=c221, @c222=c222, @c223=c223, @c224=c224, @c225=c225, @c226=c226, @c227=c227, @c228=c228, @c229=c229, @c230=c230, @c231=c231, @c232=c232, @c233=c233, @c234=c234, @c235=c235, @c236=c236, @c237=c237, @c238=c238, @c239=c239, @c240=c240, @c241=c241, @c242=c242, @c243=c243, @c244=c244, @c245=c245, @c246=c246, @c247=c247, @c248=c248, @c249=c249, @c250=c250, @c251=c251, @c252=c252, @c253=c253, @c254=c254, @c255=c255, @c256=c256, @c257=c257, @c258=c258, @c259=c259, @c260=c260, @c261=c261, @c262=c262, @c263=c263, @c264=c264, @c265=c265, @c266=c266, @c267=c267, @c268=c268, @c269=c269, @c270=c270, @c271=c271, @c272=c272, @c273=c273, @c274=c274, @c275=c275, @c276=c276, @c277=c277, @c278=c278, @c279=c279, @c280=c280, @c281=c281, @c282=c282, @c283=c283, @c284=c284, @c285=c285, @c286=c286, @c287=c287, @c288=c288, @c289=c289, @c290=c290, @c291=c291, @c292=c292, @c293=c293, @c294=c294, @c295=c295, @c296=c296, @c297=c297, @c298=c298, @c299=c299, @c300=c300, @c301=c301, @c302=c302, @c303=c303, @c304=c304, @c305=c305, @c306=c306, @c307=c307, @c308=c308, @c309=c309, @c310=c310, @c311=c311, @c312=c312, @c313=c313, @c314=c314, @c315=c315, @c316=c316, @c317=c317, @c318=c318, @c319=c319, @c320=c320, @c321=c321, @c322=c322, @c323=c323, @c324=c324, @c325=c325, @c326=c326, @c327=c327, @c328=c328, @c329=c329, @c330=c330, @c331=c331, @c332=c332, @c333=c333, @c334=c334, @c335=c335, @c336=c336, @c337=c337, @c338=c338, @c339=c339, @c340=c340, @c341=c341, @c342=c342, @c343=c343, @c344=c344, @c345=c345, @c346=c346, @c347=c347, @c348=c348, @c349=c349, @c350=c350, @c351=c351, @c352=c352, @c353=c353, @c354=c354, @c355=c355, @c356=c356, @c357=c357, @c358=c358, @c359=c359, @c360=c360, @c361=c361, @c362=c362, @c363=c363, @c364=c364, @c365=c365, @c366=c366, @c367=c367, @c368=c368, @c369=c369, @c370=c370, @c371=c371, @c372=c372, @c373=c373, @c374=c374, @c375=c375, @c376=c376, @c377=c377, @c378=c378, @c379=c379, @c380=c380, @c381=c381, @c382=c382, @c383=c383, @c384=c384, @c385=c385, @c386=c386, @c387=c387, @c388=c388, @c389=c389, @c390=c390, @c391=c391, @c392=c392, @c393=c393, @c394=c394, @c395=c395, @c396=c396, @c397=c397, @c398=c398, @c399=c399, @c400=c400, @c401=c401, @c402=c402, @c403=c403, @c404=c404, @c405=c405, @c406=c406, @c407=c407, @c408=c408, @c409=c409, @c410=c410, @c411=c411, @c412=c412, @c413=c413, @c414=c414, @c415=c415, @c416=c416, @c417=c417, @c418=c418, @c419=c419, @c420=c420, @c421=c421, @c422=c422, @c423=c423, @c424=c424, @c425=c425, @c426=c426, @c427=c427, @c428=c428, @c429=c429, @c430=c430, @c431=c431, @c432=c432, @c433=c433, @c434=c434, @c435=c435, @c436=c436, @c437=c437, @c438=c438, @c439=c439, @c440=c440, @c441=c441, @c442=c442, @c443=c443, @c444=c444, @c445=c445, @c446=c446, @c447=c447, @c448=c448, @c449=c449, @c450=c450, @c451=c451, @c452=c452, @c453=c453, @c454=c454, @c455=c455, @c456=c456, @c457=c457, @c458=c458, @c459=c459, @c460=c460, @c461=c461, @c462=c462, @c463=c463, @c464=c464, @c465=c465, @c466=c466, @c467=c467, @c468=c468, @c469=c469, @c470=c470, @c471=c471, @c472=c472, @c473=c473, @c474=c474, @c475=c475, @c476=c476, @c477=c477, @c478=c478, @c479=c479, @c480=c480, @c481=c481, @c482=c482, @c483=c483, @c484=c484, @c485=c485, @c486=c486, @c487=c487, @c488=c488, @c489=c489, @c490=c490, @c491=c491, @c492=c492, @c493=c493, @c494=c494, @c495=c495, @c496=c496, @c497=c497, @c498=c498, @c499=c499, @c500=c500, @c501=c501, @c502=c502, @c503=c503, @c504=c504, @c505=c505, @c506=c506, @c507=c507, @c508=c508, @c509=c509, @c510=c510, @c511=c511, @c512=c512, @c513=c513, @c514=c514, @c515=c515, @c516=c516, @c517=c517, @c518=c518, @c519=c519, @c520=c520, @c521=c521, @c522=c522, @c523=c523, @c524=c524, @c525=c525, @c526=c526, @c527=c527, @c528=c528, @c529=c529, @c530=c530, @c531=c531, @c532=c532, @c533=c533, @c534=c534, @c535=c535, @c536=c536, @c537=c537, @c538=c538, @c539=c539, @c540=c540, @c541=c541, @c542=c542, @c543=c543, @c544=c544, @c545=c545, @c546=c546, @c547=c547, @c548=c548, @c549=c549, @c550=c550, @c551=c551, @c552=c552, @c553=c553, @c554=c554, @c555=c555, @c556=c556, @c557=c557, @c558=c558, @c559=c559, @c560=c560, @c561=c561, @c562=c562, @c563=c563, @c564=c564, @c565=c565, @c566=c566, @c567=c567, @c568=c568, @c569=c569, @c570=c570, @c571=c571, @c572=c572, @c573=c573, @c574=c574, @c575=c575, @c576=c576, @c577=c577, @c578=c578, @c579=c579, @c580=c580, @c581=c581, @c582=c582, @c583=c583, @c584=c584, @c585=c585, @c586=c586, @c587=c587, @c588=c588, @c589=c589, @c590=c590, @c591=c591, @c592=c592, @c593=c593, @c594=c594, @c595=c595, @c596=c596, @c597=c597, @c598=c598, @c599=c599, @c600=c600, @c601=c601, @c602=c602, @c603=c603, @c604=c604, @c605=c605, @c606=c606, @c607=c607, @c608=c608, @c609=c609, @c610=c610, @c611=c611, @c612=c612, @c613=c613, @c614=c614, @c615=c615, @c616=c616, @c617=c617, @c618=c618, @c619=c619, @c620=c620, @c621=c621, @c622=c622, @c623=c623, @c624=c624, @c625=c625, @c626=c626, @c627=c627, @c628=c628, @c629=c629, @c630=c630, @c631=c631, @c632=c632, @c633=c633, @c634=c634, @c635=c635, @c636=c636, @c637=c637, @c638=c638, @c639=c639, @c640=c640, @c641=c641, @c642=c642, @c643=c643, @c644=c644, @c645=c645, @c646=c646, @c647=c647, @c648=c648, @c649=c649, @c650=c650, @c651=c651, @c652=c652, @c653=c653, @c654=c654, @c655=c655, @c656=c656, @c657=c657, @c658=c658, @c659=c659, @c660=c660, @c661=c661, @c662=c662, @c663=c663, @c664=c664, @c665=c665, @c666=c666, @c667=c667, @c668=c668, @c669=c669, @c670=c670, @c671=c671, @c672=c672, @c673=c673, @c674=c674, @c675=c675, @c676=c676, @c677=c677, @c678=c678, @c679=c679, @c680=c680, @c681=c681, @c682=c682, @c683=c683, @c684=c684, @c685=c685, @c686=c686, @c687=c687, @c688=c688, @c689=c689, @c690=c690, @c691=c691, @c692=c692, @c693=c693, @c694=c694, @c695=c695, @c696=c696, @c697=c697, @c698=c698, @c699=c699, @c700=c700, @c701=c701, @c702=c702, @c703=c703, @c704=c704, @c705=c705, @c706=c706, @c707=c707, @c708=c708, @c709=c709, @c710=c710, @c711=c711, @c712=c712, @c713=c713, @c714=c714, @c715=c715, @c716=c716, @c717=c717, @c718=c718, @c719=c719, @c720=c720, @c721=c721, @c722=c722, @c723=c723, @c724=c724, @c725=c725, @c726=c726, @c727=c727, @c728=c728, @c729=c729, @c730=c730, @c731=c731, @c732=c732, @c733=c733, @c734=c734, @c735=c735, @c736=c736, @c737=c737, @c738=c738, @c739=c739, @c740=c740, @c741=c741, @c742=c742, @c743=c743, @c744=c744, @c745=c745, @c746=c746, @c747=c747, @c748=c748, @c749=c749, @c750=c750, @c751=c751, @c752=c752, @c753=c753, @c754=c754, @c755=c755, @c756=c756, @c757=c757, @c758=c758, @c759=c759, @c760=c760, @c761=c761, @c762=c762, @c763=c763, @c764=c764, @c765=c765, @c766=c766, @c767=c767, @c768=c768, @c769=c769, @c770=c770, @c771=c771, @c772=c772, @c773=c773, @c774=c774, @c775=c775, @c776=c776, @c777=c777, @c778=c778, @c779=c779, @c780=c780, @c781=c781, @c782=c782, @c783=c783, @c784=c784, @c785=c785, @c786=c786, @c787=c787, @c788=c788, @c789=c789, @c790=c790, @c791=c791, @c792=c792, @c793=c793, @c794=c794, @c795=c795, @c796=c796, @c797=c797, @c798=c798, @c799=c799, @c800=c800, @c801=c801, @c802=c802, @c803=c803, @c804=c804, @c805=c805, @c806=c806, @c807=c807, @c808=c808, @c809=c809, @c810=c810, @c811=c811, @c812=c812, @c813=c813, @c814=c814, @c815=c815, @c816=c816, @c817=c817, @c818=c818, @c819=c819, @c820=c820, @c821=c821, @c822=c822, @c823=c823, @c824=c824, @c825=c825, @c826=c826, @c827=c827, @c828=c828, @c829=c829, @c830=c830, @c831=c831, @c832=c832, @c833=c833, @c834=c834, @c835=c835, @c836=c836, @c837=c837, @c838=c838, @c839=c839, @c840=c840, @c841=c841, @c842=c842, @c843=c843, @c844=c844, @c845=c845, @c846=c846, @c847=c847, @c848=c848, @c849=c849, @c850=c850, @c851=c851, @c852=c852, @c853=c853, @c854=c854, @c855=c855, @c856=c856, @c857=c857, @c858=c858, @c859=c859, @c860=c860, @c861=c861, @c862=c862, @c863=c863, @c864=c864, @c865=c865, @c866=c866, @c867=c867, @c868=c868, @c869=c869, @c870=c870, @c871=c871, @c872=c872, @c873=c873, @c874=c874, @c875=c875, @c876=c876, @c877=c877, @c878=c878, @c879=c879, @c880=c880, @c881=c881, @c882=c882, @c883=c883, @c884=c884, @c885=c885, @c886=c886, @c887=c887, @c888=c888, @c889=c889, @c890=c890, @c891=c891, @c892=c892, @c893=c893, @c894=c894, @c895=c895, @c896=c896, @c897=c897, @c898=c898, @c899=c899, @c900=c900, @c901=c901, @c902=c902, @c903=c903, @c904=c904, @c905=c905, @c906=c906, @c907=c907, @c908=c908, @c909=c909, @c910=c910, @c911=c911, @c912=c912, @c913=c913, @c914=c914, @c915=c915, @c916=c916, @c917=c917, @c918=c918, @c919=c919, @c920=c920, @c921=c921, @c922=c922, @c923=c923, @c924=c924, @c925=c925, @c926=c926, @c927=c927, @c928=c928, @c929=c929, @c930=c930, @c931=c931, @c932=c932, @c933=c933, @c934=c934, @c935=c935, @c936=c936, @c937=c937, @c938=c938, @c939=c939, @c940=c940, @c941=c941, @c942=c942, @c943=c943, @c944=c944, @c945=c945, @c946=c946, @c947=c947, @c948=c948, @c949=c949, @c950=c950, @c951=c951, @c952=c952, @c953=c953, @c954=c954, @c955=c955, @c956=c956, @c957=c957, @c958=c958, @c959=c959, @c960=c960, @c961=c961, @c962=c962, @c963=c963, @c964=c964, @c965=c965, @c966=c966, @c967=c967, @c968=c968, @c969=c969, @c970=c970, @c971=c971, @c972=c972, @c973=c973, @c974=c974, @c975=c975, @c976=c976, @c977=c977, @c978=c978, @c979=c979, @c980=c980, @c981=c981, @c982=c982, @c983=c983, @c984=c984, @c985=c985, @c986=c986, @c987=c987, @c988=c988, @c989=c989, @c990=c990, @c991=c991, @c992=c992, @c993=c993, @c994=c994, @c995=c995, @c996=c996, @c997=c997, @c998=c998, @c999=c999, @c1000=c1000 
	FROM [NonSparseDocRepository] ORDER BY [c' +
		CAST (CONVERT (INT, RAND () * 1000) AS VARCHAR) +
		'] DESC OPTION (MAXDOP 8)';
		
	EXEC (@ExecString);
	
	WAITFOR DELAY '00:00:00.5';
END;
GO

-- Explain os_waiting_tasks - problem is thread not waiting for CXPACKET
-- Refresh a few times to see LATCH_EX showing up

-- Look at latch stats

-- Look at stats

-- Add in OPTION (MAXDOP 4), look at stats

-- Add in OPTION (MAXDOP 2), look at stats

-- Add in OPTION (MAXDOP 1), look at stats