﻿#import the UserRights module
#https://gallery.technet.microsoft.com/scriptcenter/Grant-Revoke-Query-user-26e259b0
import-module C:\SQLskills\M1\SystemHealth\UserRights.psm1

# Is LPIM enabled?
Get-AccountsWithUserRight -Right SeLockMemoryPrivilege

# Is IFI enabled?
Get-AccountsWithUserRight -Right SeManageVolumePrivilege

# Computer Info
Get-WmiObject win32_computersystem

# Socket Info
Get-WmiObject win32_processor

# Number of processors
Get-WmiObject win32_computersystem | foreach {$env:NUMBER_OF_PROCESSORS}

# Socket and process info
$property = "systemname","maxclockspeed","addressWidth",

            "numberOfCores", "NumberOfLogicalProcessors"

Get-WmiObject -class win32_processor -Property  $property |

Select-Object -Property $property 

# Server Memory
Get-WmiObject win32_computersystem | foreach {$_.TotalPhysicalMemory / 1GB}